VERSION 8000; ; 8308
* -----------------------------------------------------------------------------
* @filedoc
* @file Beispiel_Quicksort.CSX
* @brief Schnelles Sortieren eines Feldes mit Quicksort
* 
* Dieses Beispielskript zeigt, wie Sie mithilfe von Feldsymbolen 
* Werte aus einer Datei lesen und auf- oder absteigend schnell sortieren.
* Die sortierten Werte werden in eine Datei gespeichert.

* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author BB
* @endfiledoc
* -----------------------------------------------------------------------------
*    8300 18.12.09 BB
*    8308 03.08.12 JH   auf neues Dialogsystem umgestellt 
* @history
* -----------------------------------------------------------------------------


* --- Vereinbarungen ----------------------------------------------------------

$Prfstufe 7

BILDSCHIRM GRAFIK                                | Meldungen im Arbeitsprotokoll ausgeben

* --- Deklarationen -------------------------------------------------

SYMBOLE * EinFeld(32000)                         | Symbolfelder
SYMBOLE * Mode; Feld; Skrit; Anzwert; i; Falsch; Startwert
SYMBOLE * delta
SYMBOLE * !DatName_Ein; !DatName_Aus
SYMBOLE * Ret

Mode = 0                                         | Dialogmodus
Feld = 1                                         | Feldposition
Skrit = 1                                        | Sortierung: 1 = aufsteigend, 2 = absteigend
delta=0,0
!DatName_Ein = "<?>Zufallszahlen.CSV"               | Name der Eingabedatei
!DatName_Aus = "SortierErgebnis.PRT"             | Name der Ergebnisdatei


* --- Ausfhrung --------------------------------------------------------------

*** Dialogfhrung
Ret = DIALOG()
WENN RET == 0 DANN STOP  |Dialog wurde abgebrochen

*** Schleife zum Auslesen von Datenzeilen einer Datei 

DAT_AUF 1; Name = !DatName_Ein                             | ffnet die Datei
AnzWert = 0

SCHLEIFE i = 1; 32000
  DAT_LESEN 1; Falsch; "*"; EinFeld(i)                     | liest Zeile aus der geffneten Datei
  WENN Falsch <> 0 DANN ABBRUCH SCHLEIFE
  AnzWert = AnzWert + 1
ENDE SCHLEIFE

DAT_ZU 1                                                   | schliet die Datei

MELDE "# Werte aus Datei # gelesen, Sortierung wird begonnen ..."; AnzWert; !DatName_Ein

*** Sortierung und Dateiausgabe der Werte 

Startwert=1

DAT_NEU 2; Name = !DatName_Aus                             | legt neue Datei an

QuickSort [EinFeld]; Startwert; AnzWert         | Quicksort aufrufen

WENN Skrit =1 DANN
  SCHLEIFE i = 1; AnzWert
    DAT_SCHREIBEN 2; "#.#####"; EinFeld(i)                   | schreibt die Zeile in Datei
  ENDE SCHLEIFE
SONST
  SCHLEIFE i = AnzWert; 1; -1
    DAT_SCHREIBEN 2; "#.#####"; EinFeld(i)                   | schreibt die Zeile in Datei
  ENDE SCHLEIFE
WEITER

DAT_ZU 2                                                   | schliet Datei

DAT_BEARBEITEN !DatName_Aus

STOP

* --- Funktionsblcke ---------------------------------------------------------
FUNKTION QUICKSORT: a(); links; rechts 

  SYMBOLE * i;j
  SYMBOLE * m;m1;m2
  SYMBOLE * v;zp

WENN rechts>links DANN
  v=a((links+rechts)/2)
  i=links
  j=rechts

  SOLANGE m=1

    SOLANGE m1= a(i)<v
      i=i+1
    ENDE SOLANGE 

    SOLANGE m2= v<a(j)
      j=j-1
    ENDE SOLANGE 

    WENN (i>j) DANN ABBRUCH SOLANGE
    zp=a(i)
    a(i)=a(j)
    a(j)=zp
    i=i+1
    j=j-1
  ENDE SOLANGE

  WENN links<j DANN QUICKSORT [a]; links; j
  WENN i<rechts DANN QUICKSORT [a]; i; rechts
WEITER

ENDE FUNKTION

* ----------------------------------
FUNKTION DIALOG:
   EXTERN * Skrit 
   SYMBOLE * Ret
   SYMBOLE /DLG_WINDOW/ Dialog      | Dialogfenster
   SYMBOLE /DLG_COMBOBOX/ Combo     | Combobox 

  
   Dialog = NewObject /DLG_WINDOW/     | Anlegen 
   Dialog.SetCaption("Sortierung eines Datenfeldes aus einer Datei")     | berschrift des Fensters 
   
   Combo = NewObject /DLG_COMBOBOX/    | Combo Feld Anlegen
   Combo.SetLabel("Sortierung:")       | Beschreibung festlegen             
   Combo.SetSize(50)
   Combo.SetValue(Skrit)
   Combo.AddText("aufsteigend"; 1)     | 1. Vorgabetexte fr Auswahlliste setzen
   Combo.AddText("absteigend"; 2)    
   Dialog.AddField(Combo)              | Feld am Dialog Anmelden

   Ret = Dialog.DoDialog(1)            | Dialog ausfhren

   Wenn Ret Dann 
     Skrit = Combo.GetValue()        
   WEITER

ENDE FUNKTION